# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(DBI::Test) when available

Name:		perl-DBD-CSV
Version:	0.57
Release:	1.%{__distinit}%{__distvers}
Summary:	DBI driver for CSV files
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/DBD-CSV
Source0:	https://cpan.metacpan.org/authors/id/H/HM/HMBRAND/DBD-CSV-%{version}.tgz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(DBD::File) >= 0.42
BuildRequires:	perl(DBI) >= 1.628
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(SQL::Statement) >= 1.405
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::CSV_XS) >= 1.01
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(charnames)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Test::More) >= 0.90
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "$(perl -V:version)"; echo $version))
Requires:	perl(Exporter)
Requires:	perl(SQL::Statement) >= 1.405
Requires:	perl(Text::CSV_XS) >= 1.01

%description
The DBD::CSV module is yet another driver for the DBI (Database
independent interface for Perl). This one is based on the SQL
"engine" SQL::Statement and the abstract DBI driver DBD::File
and implements access to so-called CSV files (Comma separated
values). Such files are mostly used for exporting MS Access and
MS Excel data.

%prep
%setup -q -n DBD-CSV-%{version}
chmod -c a-x ChangeLog README lib/DBD/*.pm lib/Bundle/DBD/*.pm

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc ChangeLog CONTRIBUTING.md README
%{perl_vendorlib}/Bundle/
%{perl_vendorlib}/DBD/
%{_mandir}/man3/Bundle::DBD::CSV.3*
%{_mandir}/man3/DBD::CSV.3*

%changelog
* Fri Dec 18 2020 Paul Howarth <paul@city-fan.org> - 0.57-1
- Update to 0.57
  - META fixes

* Sat Dec  5 2020 Paul Howarth <paul@city-fan.org> - 0.56-1
- Update to 0.56
  - Fix Changes (add missing entry for 0.54)
  - Bugtrackter ⇒ GitHub Issues
  - f_dir should exist (CVE fix in DBI-1.644 / DBD::File-0.45)
  - TODO tests better skipped if failing

* Mon Jul 27 2020 Paul Howarth <paul@city-fan.org> - 0.55-1
- Update to 0.55
  - It's 2020
  - Provide cpanfile
  - Documentation enhancements
  - Make csv_ and f_ aliases more consistently available (GH#7)

* Mon Oct 29 2018 Paul Howarth <paul@city-fan.org> - 0.54-1
- Update to 0.54
  - Free unref scalar test fixed in Text::CSV_XS 1.35

* Mon May 21 2018 Paul Howarth <paul@city-fan.org> - 0.53-1
- Update to 0.53
  - No folder scanning during automated tests
  - Fix col_names set to empty [] incorrectly skipping first row (GH#6)
  - Small doc fix
  - Tested on FreeBSD
- Switch upstream from search.cpan.org to metacpan.org

* Thu Apr  5 2018 Paul Howarth <paul@city-fan.org> - 0.52-1
- Update to 0.52
  - More test fixes for Perl without dot in @INC

* Sun Mar 25 2018 Paul Howarth <paul@city-fan.org> - 0.51-1
- Update to 0.51
  - Fix tests for Perl without dot in @INC

* Thu Mar 22 2018 Paul Howarth <paul@city-fan.org> - 0.50-1
- Update to 0.50
  - Explain more about header folding
  - BOM handling
  - Some documentation enhancements
  - Ignore DBI_DSN if it is not CSV
  - It's 2018
  - Test with perl-5.26, DBI-1.641, SQL::Statement-1.412, and Text::CSV_XS-1.35
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.88

* Thu May 12 2016 Paul Howarth <paul@city-fan.org> - 0.49-1
- Update to 0.49
  - Simplified test-table-name generation
  - Prefer quote_empty over quote_always for size (Text::CSV_XS => 1.18)
  - Add CONTRIBUTING.md
  - It's 2016
  - Added docs to warn for reserved words (CPAN RT#106529)
  - Minor spelling corrections
  - Test with perl 5.24.0, DBI 1.636, SQL::Statement 1.410, Text::CSV_XS 1.23
- BR: perl-generators where possible
- Simplify find command using -delete

* Sun Jun 28 2015 Paul Howarth <paul@city-fan.org> - 0.48-3
- Perl 5.22 rebuild

* Thu Feb 12 2015 Paul Howarth <paul@city-fan.org> - 0.48-1
- Update to 0.48
  - Update list of valid Text::CSV_XS attributes

* Wed Feb 11 2015 Paul Howarth <paul@city-fan.org> - 0.47-1
- Update to 0.47
  - Updated copyright to 2015
  - Make test-tablename unique for parallel testing
  - Remove perl recommendation from META as it breaks cpan clients
- Classify buildreqs by usage
- Update patches as needed

* Sun Nov 16 2014 Paul Howarth <paul@city-fan.org> - 0.46-1
- Update to 0.46
  - Column type CHAR should return 1
- Update patches as needed

* Thu Oct 23 2014 Paul Howarth <paul@city-fan.org> - 0.45-1
- Update to 0.45
  - Test unauthorized folder access (CPAN RT#99508)
  - Fix DBI requirement phase (depend more on toolchain) (CPAN RT#99732)
- Update patches as needed

* Mon Sep 15 2014 Paul Howarth <paul@city-fan.org> - 0.44-2
- Perl 5.20 rebuild

* Thu Aug 14 2014 Paul Howarth <paul@city-fan.org> - 0.44-1
- Update to 0.44
  - Table names case sensitiveness not tested on case-problematic FS's
  - Fix defaults in documentation
  - Fix typo in SYNOPSIS (CPAN RT#97313)
  - Work around EOF bug in Text::CSV_XS-1.10

* Tue Jul  1 2014 Paul Howarth <paul@city-fan.org> - 0.43-1
- Update to 0.43
  - Optionally skip tests using File::Spec->tempdir() (CPAN RT#87684)
  - Document the use of $TMPDIR in README
  - Make the SYNOPSIS more reflect real-world usage
  - Detect DBI::Test and use it if available
  - Unquote schemas in test for cygwin
  - Extra guards in Makefile.PL for unmet requirements
- Exclude new test modules, which generate a bunch of new dependencies
- Update patches as needed
- Drop %%defattr, redundant since rpm 4.4

* Mon Jul 29 2013 Paul Howarth <paul@city-fan.org> - 0.41-1
- Update to 0.41
  - Use File::Spec->tmpdir () for universal existing folder (note that huge
    $TMP folders may cause the test to run slowly)
  - Use File::Spec::rel2abs () instead of abs_path and hoops
  - Guard against parallel testing, which is unsupported
  - Guard against streaming tests (they PASS on the DBI-devel)
- Update patch for building with Test::More < 0.88
- Add patch to support building with Test::More < 0.82

* Tue Jul 23 2013 Paul Howarth <paul@city-fan.org> - 0.40-1
- Update to 0.40
  - Fix version references in docs
  - Fix tests for Windows
- Update patch for building with old Test::More versions

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> - 0.39-1
- Update to 0.39
  - Use f_file in docs; file is deprecated
  - DBD::CSV's repository moved to github
  - Add test for row-completeness
  - Fix UTF-8 tests to better follow Text::CSV_XS auto-encoding
  - Require more recent versions of low level modules that fix issues reported
    for DBD::CSV
  - Development will also do most tests with DBI_SQL_NANO=1
  - Added support for f_dir_search from DBD::File (in fact DBI was changed to
    feature this for DBD::CSV)
  - Fix test relying on spell-error in DBI's error message
  - Document csv_class (still under-tested)
- Bump version requirements for dependencies as per upstream
- Update patch for building with old Test::More versions
- BR: perl(version), needed for new test t/61_meta.t

* Thu Jan 10 2013 Paul Howarth <paul@city-fan.org> - 0.38-1
- Update to 0.38
  - Fixed CPAN RT#80078, resulting in getline calls on undef
  - Require latest DBI and SQL::Statement
  - Updated copyright to 2013
  - Fixes for DBI-1.623
- Bump version requirements for dependencies as per upstream
- Update patch for building with old Test::More versions

* Sun Aug 26 2012 Paul Howarth <paul@city-fan.org> - 0.36-1
- Update to 0.36
  - Add line/record number and position in error messages
- Update patch for building with old Test::More versions
- Bump perl(DBI) version requirement to 1.622
- Bump perl(Text::CSV_XS) version requirement to 0.91

* Sun Jul 15 2012 Paul Howarth <paul@city-fan.org> - 0.35-2
- BR: perl(Cwd), perl(Encode) and perl(File::Spec)

* Fri May 25 2012 Paul Howarth <paul@city-fan.org> - 0.35-1
- Update to 0.35
  - Improved documentation
  - Tested under 5.16.0

* Sat May 12 2012 Paul Howarth <paul@city-fan.org> - 0.34-1
- Update to 0.34
  - Updated copyright to 2012
  - Require 5.8.1, as DBI does
  - Tested against perl-5.16.0-RC0 + DBI-1.620
- BR: perl(Carp) and perl(IO::File)
- Bump version requirement of DBI to 1.620
- Bump version requirement of Text::CSV_XS to 0.88
- Don't need to remove empty directories from buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}

* Thu Sep  8 2011 Paul Howarth <paul@city-fan.org> - 0.33-1
- Update to 0.33
  - NAME / DISTNAME in Makefile.PL
  - TYPE should be numeric
  - Added tests for return count of delete statements in do
  - Upped copyright to 2011
  - Added tests for return count of update statements
  - Try to catch (more) usernames on Windows as schema names
  - More cross-checks for META data
- Update patch for building with old Test::More versions

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> - 0.31-2
- Rebuild for perl 5.14.1 in Rawhide
- Use %%{_fixperms} macro rather than our own %%{__chmod} incantation
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Mon Sep 20 2010 Paul Howarth <paul@city-fan.org> - 0.31-1
- Update to 0.31:
  - Require 5.8.1 (effectively already doing so by requiring DBI-1.614)
  - Update tests to use warnings and done_testing()
  - Better diagnostics for empty files
  - Allow late setting of attributes (CPAN RT#61168)
- Update patch for old Test::More versions and apply it if Test::More < 0.88
- Bump SQL::Statement version requirement to 1.31
- Bump DBI version requirement to 1.614
- Bump DBD::File version requirement to 0.40

* Tue Aug 10 2010 Paul Howarth <paul@city-fan.org> - 0.30-2
- Import from Fedora
- Add patch to get t/11_dsnlist.t working with Test::More < 0.61

* Mon Jul 12 2010 Petr Pisar <ppisar@redhat.com> - 0.30-1
- 0.30 bump (bug #613251)

* Tue Jun  8 2010 Petr Pisar <ppisar@redhat.com> - 0.29-1
- 0.29 bump

* Fri Apr 30 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.27-2
- Mass rebuild with perl-5.12.0

* Thu Mar 11 2010 Marcela Mašláňová <mmaslano@redhat.com> - 0.27-1
- Update
- Replace DESTDIR

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.22-9
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.22-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.22-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb  2 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-6
- Rebuild for new perl

* Mon Oct 15 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-5.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Tue Sep 26 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-5
- Added perl(SQL::Statement) to requirements list (#208012)

* Thu Sep  7 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-4
- Rebuild for FC6

* Fri Feb 24 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-3
- Rebuild for FC5 (perl 5.8.8)

* Sat Dec 17 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-2
- Missing build requirement: DBD::File >= 0.30

* Sun Sep 11 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-1
- First build
